Loading...
Searching...
No Matches
pcl::ProgressiveSampleConsensus< PointT > Class Template Reference
Module sample_consensus

ProgressiveSampleConsensus represents an implementation of the PROSAC (PROgressive SAmple Consensus) algorithm, as described in: "Matching with PROSAC – Progressive Sample Consensus", Chum, O. More...

`#include <pcl/sample_consensus/prosac.h>`

Inheritance diagram for pcl::ProgressiveSampleConsensus< PointT >:

## Public Types

using | Ptr = shared_ptr<ProgressiveSampleConsensus>
using | ConstPtr = shared_ptr<const ProgressiveSampleConsensus>
Public Types inherited from pcl::SampleConsensus< PointT >
using | Ptr
using | ConstPtr

## Public Member Functions

| ProgressiveSampleConsensus (const SampleConsensusModelPtr &model)
| PROSAC (Progressive SAmple Consensus) main constructor.
| ProgressiveSampleConsensus (const SampleConsensusModelPtr &model, double threshold)
| PROSAC (Progressive SAmple Consensus) main constructor.
bool | computeModel (int debug_verbosity_level=0) override
| Compute the actual model and find the inliers.
Public Member Functions inherited from pcl::SampleConsensus< PointT >
void | setSampleConsensusModel (const SampleConsensusModelPtr &model)
| Set the Sample Consensus model to use.
SampleConsensusModelPtr | getSampleConsensusModel () const
| Get the Sample Consensus model used.
virtual | ~SampleConsensus ()=default
| Destructor for base SAC.
void | setDistanceThreshold (double threshold)
| Set the distance to model threshold.
double | getDistanceThreshold () const
| Get the distance to model threshold, as set by the user.
void | setMaxIterations (int max_iterations)
| Set the maximum number of iterations.
int | getMaxIterations () const
| Get the maximum number of iterations, as set by the user.
void | setProbability (double probability)
| Set the desired probability of choosing at least one sample free from outliers.
double | getProbability () const
| Obtain the probability of choosing at least one sample free from outliers, as set by the user.
void | setNumberOfThreads (const int nr_threads=-1)
| Set the number of threads to use or turn off parallelization.
int | getNumberOfThreads () const
| Get the number of threads, as set by the user.
virtual bool | refineModel (const double sigma=3.0, const unsigned int max_iterations=1000)
| Refine the model found.
void | getRandomSamples (const IndicesPtr &indices, std::size_t nr_samples, std::set< index_t > &indices_subset)
| Get a set of randomly selected indices.
void | getModel (Indices &model) const
| Return the best model found so far.
void | getInliers (Indices &inliers) const
| Return the best set of inliers found so far for this model.
void | getModelCoefficients (Eigen::VectorXf &model_coefficients) const
| Return the model coefficients of the best model found so far.

## Additional Inherited Members

Protected Member Functions inherited from pcl::SampleConsensus< PointT >
double | rnd ()
| Boost-based random number generator.
Protected Attributes inherited from pcl::SampleConsensus< PointT >
SampleConsensusModelPtr | sac_model_
| The underlying data model used (i.e.
Indices | model_
| The model found after the last computeModel () as point cloud indices.
Indices | inliers_
| The indices of the points that were chosen as inliers after the last computeModel () call.
Eigen::VectorXf | model_coefficients_
| The coefficients of our model computed directly from the model found.
double | probability_
| Desired probability of choosing at least one sample free from outliers.
int | iterations_
| Total number of internal loop iterations that we've done so far.
double | threshold_
| Distance to model threshold.
int | max_iterations_
| Maximum number of iterations before giving up.
int | threads_
| The number of threads the scheduler should use, or a negative number if no parallelization is wanted.
boost::mt19937 | rng_alg_
| Boost-based random number generator algorithm.
std::shared_ptr< boost::uniform_01< boost::mt19937 > > | rng_
| Boost-based random number generator distribution.

## Detailed Description

template<typename PointT>
class pcl::ProgressiveSampleConsensus< PointT >

ProgressiveSampleConsensus represents an implementation of the PROSAC (PROgressive SAmple Consensus) algorithm, as described in: "Matching with PROSAC – Progressive Sample Consensus", Chum, O.

and Matas, J.G., CVPR, I: 220-226 2005.

Author
  Vincent Rabaud

Definition at line 55 of file prosac.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointT>

using pcl::ProgressiveSampleConsensus< PointT >::ConstPtr = shared_ptr<const ProgressiveSampleConsensus>

Definition at line 61 of file prosac.h.

## Ptr

template<typename PointT>

using pcl::ProgressiveSampleConsensus< PointT >::Ptr = shared_ptr<ProgressiveSampleConsensus>

Definition at line 60 of file prosac.h.

## Constructor & Destructor Documentation

## ProgressiveSampleConsensus() [1/2]

template<typename PointT>

pcl::ProgressiveSampleConsensus< PointT >::ProgressiveSampleConsensus | ( | const SampleConsensusModelPtr & | model | ) |

inline

PROSAC (Progressive SAmple Consensus) main constructor.

Parameters

  [in] | model | a Sample Consensus model

Definition at line 75 of file prosac.h.

References pcl::SampleConsensus< PointT >::max_iterations_.

## ProgressiveSampleConsensus() [2/2]

template<typename PointT>

pcl::ProgressiveSampleConsensus< PointT >::ProgressiveSampleConsensus | ( | const SampleConsensusModelPtr & | model,
|  | double | threshold )

inline

PROSAC (Progressive SAmple Consensus) main constructor.

Parameters

  [in] | model | a Sample Consensus model
  [in] | threshold | distance to model threshold

Definition at line 86 of file prosac.h.

References pcl::SampleConsensus< PointT >::max_iterations_.

## Member Function Documentation

## computeModel()

template<typename PointT>

bool pcl::ProgressiveSampleConsensus< PointT >::computeModel | ( | int | debug_verbosity_level = 0 | ) |

override virtual

Compute the actual model and find the inliers.

Parameters

  [in] | debug_verbosity_level | enable/disable on-screen debug information and set the verbosity level

Implements pcl::SampleConsensus< PointT >.

Definition at line 56 of file prosac.hpp.

References pcl::SampleConsensus< PointT >::inliers_, pcl::SampleConsensus< PointT >::iterations_, pcl::SampleConsensus< PointT >::max_iterations_, pcl::SampleConsensus< PointT >::model_, pcl::SampleConsensus< PointT >::model_coefficients_, pcl::SampleConsensus< PointT >::sac_model_, and pcl::SampleConsensus< PointT >::threshold_.

The documentation for this class was generated from the following files:

- pcl/sample_consensus/prosac.h
- pcl/sample_consensus/impl/prosac.hpp